#include "vector.h"
#include <iostream>
#include <cmath>

int CVector::counter = 0;

CVector::CVector(int x, int y, int z)
{
 mX = x;
 mY = y;
 mZ = z;
 counter++;
}
 
CVector::CVector(CPoint p1, CPoint p2)
{
 mX = p2.getX() - p1.getX();
 mY = p2.getY() - p1.getY();
 mZ = p2.getZ() - p1.getZ();
 counter++;
}

CVector::CVector(CVector & vect)
{
 vect.getXYZ(mX, mY, mZ);
 counter++;
}

CVector::~CVector()
{
 counter--;
}

void CVector::show(void)
{
 std::cout << "[ " << mX << ", " << mY << ", " << mZ << " ]";
}

int CVector::getCounter(void)
{
 return counter;
}

void CVector::getXYZ(int & x, int & y, int & z)
{
 x = mX;
 y = mY;
 z = mZ;
}

CVector * CVector::add(int x, int y, int z)
{
 CVector * res;
 res = new CVector(mX + x, mY + y, mZ + z);
 return res;
}

CVector * CVector::add(CVector & vect)
{
 int x, y ,z;
 vect.getXYZ(x, y, z);
 return add(x, y, z);
}

CVector * CVector::sub(int x, int y, int z)
{
 CVector * res;
 res = new CVector(mX - x, mY - y, mZ - z);
 return res;
}

CVector * CVector::sub(CVector & vect)
{
 int x, y ,z;
 vect.getXYZ(x, y, z);
 return sub(x, y, z);
}

double CVector::len(void)
{
 double t1 = (double)mX*(double)mX;
 double t2 = (double)mY*(double)mY;
 double t3 = (double)mZ*(double)mZ;
 return sqrt(t1 + t2 + t3);
}

int CVector::mul(int x, int y, int z)
{
 return (mX*x)+(mY*y)+(mZ*z);
}

int CVector::mul(CVector & vect)
{
 int x, y ,z;
 vect.getXYZ(x, y, z);
 return mul(x, y, z);
}
